/**
 * @file
 * @brief %Classifier windows implementation
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-03-02 14:02:00 +0100 (Die, 02 Mär 2004) $
 * $Revision: 677 $
 *
 * @since    Wed Mar 19 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: WindowsClassifier.cpp 677 2004-03-02 13:02:00Z rene-cvs $
 */

#include "Classifier.h"

Classifier::Classifier(const string &name, const classifierparams &params)
{
	getClassifier_t getClassifier = NULL;

	ca = NULL;

#ifdef _WIN32_WCE
	size_t len = name.size() + 1;
	wchar_t *buffer = new wchar_t[mbstowcs(NULL, name.c_str(), len)];
	mbstowcs(buffer, name.c_str(), len);

	if ((dll = LoadLibrary(buffer)) == NULL) {
#else
	if ((dll = LoadLibrary(name.c_str())) == NULL) {
#endif

		LPTSTR lpMsgBuf;

		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			0,
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);

		MessageBox(NULL, lpMsgBuf, TEXT("Error"), MB_OK|MB_ICONINFORMATION);
		LocalFree(lpMsgBuf);
	} else if ((getClassifier = (getClassifier_t) GetProcAddress(dll, TEXT("getClassifier"))) == NULL) {
		FreeLibrary(dll);
	} else {
		ca = getClassifier(params);
		dll_init_log(dll);
	}

#ifdef _WIN32_WCE
	delete buffer;
#endif
}

Classifier::~Classifier()
{
	delete f;
	FreeLibrary(dll);
}