/**
 * @file
 * @brief Persistant file reader
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-23 12:25:42 +0100 (Mon, 23 Feb 2004) $
 * $Revision: 637 $
 *
 * @since    Mon Aug 11 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: PersistantReader.h 637 2004-02-23 11:25:42Z rene $
 */

#ifndef _PERSISTANTREADER_H
#define _PERSISTANTREADER_H

#include "PersistantWriter.h"
#include "../thirdparty/scew/types.h"

/**
 * @todo documentation
 */
class PersistantReader {
	/** Friend class */
	friend class PersistantWriter;

	private:
		/** @todo name type */
		map<string, featureparams> data;

	public:
		/**
		 * Constructor
		 *
		 * Load persistant file, validate xml and
		 * copy the information into the data collection.
		 * 
		 * @param file Path to the persistant file
		 */
		PersistantReader(const char *file);
		/** @todo documentation */
		featureparams *getPersistantData(string feature);
};

#endif // _PERSISTANTREADER_H

