/**
 * @file
 * @brief Persistant file writer
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-01-15 15:46:26 +0100 (Don, 15 Jän 2004) $
 * $Revision: 510 $
 *
 * @since    Mon Aug 11 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: PersistantWriter.cpp 510 2004-01-15 14:46:26Z harald $
 */

#include "../FeatureContainer/FeatureContainer.h"
#include "PersistantReader.h"
#include "PersistantWriter.h"

void PersistantWriter::write(const char *file, map<string, featureparams> persistdata)
{
	PersistantReader *r = new PersistantReader(file);
	FILE *out;

	for (map<string, featureparams>::iterator iter1 = persistdata.begin(); iter1 != persistdata.end(); iter1++) {
		for (featureparams::iterator iter2 = (*iter1).second.begin(); iter2 != (*iter1).second.end(); iter2++) {
			r->data[(*iter1).first][(*iter2).first] = (*iter2).second;
		}
	}

	if ((out = fopen(file, "w")) != NULL) {
		fputs("<persistant>\n", out);
		for (map<string, featureparams>::iterator iter3 = r->data.begin(); iter3 != r->data.end(); iter3++) {
			fprintf(out, "\t<feature id=\"%s\">\n", (*iter3).first.c_str());
			for (featureparams::iterator iter4 = (*iter3).second.begin(); iter4 != (*iter3).second.end(); iter4++) {
				fprintf(out, "\t\t<element id=\"%s\"><![CDATA[%s]]></element>\n", (*iter4).first.c_str(), (*iter4).second.c_str());
			}
			fputs("\t</feature>\n", out);
		}
		fputs("</persistant>", out);

		fclose(out);
	} else {
		plog("Couldn't open file %s for writing.", file);
	}

	delete r;
}

/* load new samples and write persist file * /
	if ((out = fopen(persist, "w")) != NULL) {
		fputs("<persistant>\n", out);

		for (featuremap::iterator iter2 = features.begin(); iter2 != features.end(); iter2++) {
			const char *p, *feat = (*iter2).first.c_str();
			for (p = feat; *p != '.'; p++); p++;

			Feature *f = (*iter2).second->getSample(p);
			feature.push_back(f);

			if ((f != NULL) && (f->externalize())) {
				featureparams params = ((PersistantFeature *) f)->write();

				fprintf(out, "\t<feature id=\"%s\">\n", feat);
				for (featureparams::iterator iter3 = params.begin(); iter3 != params.end(); iter3++) {
					fprintf(out, "\t\t<element id=\"%s\"><![CDATA[%s]]></element>\n", (*iter3).first.c_str(), (*iter3).second.c_str());
				}
				fputs("\t</feature>\n", out);
			}
		}

		fputs("</persistant>", out);
		fclose(out);
		out = NULL;
*/

