/**
 * @file
 * @brief %Feature container
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-12 21:08:39 +0100 (Don, 12 Feb 2004) $
 * $Revision: 612 $
 *
 * @since    Thu Apr 10 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: LoggingFeatureContainer.h 612 2004-02-12 20:08:39Z harald $
 */

#ifndef _LOGGINGFEATURECONTAINER_H
#define _LOGGINGFEATURECONTAINER_H

#include "FeatureContainer.h"

/**
 * @todo documentation
 */
class LoggingFeatureContainer : public FeatureContainer {
	private:
		FILE *out;

	public:
		/**
		 * Constructor
		 *
		 * Initiaizes a logfile and logs all operations
		 * performed on the underlaying FeatureContainer
		 * class for later replay.
		 *
		 * @param config A ConfigReader instance
		 * @see FeatureContainer
		 */
		LoggingFeatureContainer(ConfigReader *config);
		/** Destructor */
		virtual ~LoggingFeatureContainer();

		virtual void nextSample();
};

#endif // _LOGGINGFEATURECONTAINER_H
