/**
 * @file
 * @brief %Feature container
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-12 21:08:39 +0100 (Don, 12 Feb 2004) $
 * $Revision: 612 $
 *
 * @since    Thu Apr 10 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: ReplayFeatureContainer.h 612 2004-02-12 20:08:39Z harald $
 */

#ifndef _REPLAYFEATURECONTAINER_H
#define _REPLAYFEATURECONTAINER_H

#include "FeatureContainer.h"

/**
 * @todo documentation
 */
class ReplayFeatureContainer : public FeatureContainer {
	private:
		//@{
		/** @todo documentation */
		//ifstream in; // Fuck ifstream ! it works on small files, but is unable to open a >30MB file correctly !
		FILE *in;
		featurevector s;
		//@}

	public:
		/**
		 * Constructor
		 *
		 * Replays any transactions stored in the logfile from
		 * a LoggingFeatureContainer.
		 *
		 * @param config A ConfigReader instance
		 */
		ReplayFeatureContainer(ConfigReader *config);
		/** Destructor */
		virtual ~ReplayFeatureContainer();

		virtual void nextSample();
		virtual const featurevector* getSampleVector() const;

		/** Reset log file handle position */
		void resetFile();
		/** Get log file size */
		long getFilesize();
		/** Get log file handle position */
		long getCurrentPos();
};

#endif // _REPLAYFEATURECONTAINER_H
