/**
 * @file
 * @brief Microphone feature
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-12 21:08:39 +0100 (Don, 12 Feb 2004) $
 * $Revision: 612 $
 *
 * @since    Wed Apr 9 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: PaWrapper.h 612 2004-02-12 20:08:39Z harald $
 */

#ifndef _PAWRAPPER_H
#define _PAWRAPPER_H

#include "../../thirdparty/portaudio/pa_common/portaudio.h"

//@{
/** Logging function for portaudio specific logging */
#ifdef DEBUG_AUDIO
# define log_audio log
#else
# define log_audio _logfoo
#endif
//@}

#ifdef _WIN32_WCE
# define Fixed_Pa_GetDefaultInputDeviceID() 1
#else
/// this returns "0" on Compaq Ipaq, but "1" is the correct input device ID
# define Fixed_Pa_GetDefaultInputDeviceID() Pa_GetDefaultInputDeviceID()
#endif

/** Sample type identifier */
#define PA_SAMPLE_TYPE  paInt16
/** Sample type */
typedef short SAMPLE;

/** Sampling rate */
#define SAMPLING_RATE 22050

#endif // _PAWRAPPER_H
