/**
 * @file
 * @brief PHP feature
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-12 21:08:39 +0100 (Don, 12 Feb 2004) $
 * $Revision: 612 $
 *
 * @since    Mon Sep 8 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: PHPWrapper.cpp 612 2004-02-12 20:08:39Z harald $
 */

#include "PHPWrapper.h"
#include "PHPCommon.h"

extern "C" void init_php();
extern "C" void shutdown_php();

extern "C" PHPFeatureType php_init_feature(const char* file);
extern "C" void* php_next_sample(const char *file, PHPFeatureType type);
extern "C" void* php_move_towards(const char *file, PHPFeatureType type, void *a, void *b);
extern "C" double php_get_distance(const char *file, PHPFeatureType type, void *a, void *b);

stringvector PHPWrapperFeatureProvider::features;

EXPORT_FEATURE(PHPWrapperFeatureProvider);

PHPWrapperFeatureProvider::PHPWrapperFeatureProvider(providerparams &params) : FeatureProvider("PHP", &features)
{
	init_php();
	string php = "PHP.";

	for (featureparams::iterator iter = params.begin(); iter != params.end(); iter++) {
		features.push_back(php + (*iter).first);
		
		PHPFeatureType type = php_init_feature((*iter).second.c_str());
		if (type != Error) {
		}
	}
}

PHPWrapperFeatureProvider::~PHPWrapperFeatureProvider()
{
	shutdown_php();
}

void PHPWrapperFeatureProvider::nextSample(clock_t checkpoint)
{
}

Feature* PHPWrapperFeatureProvider::getFeature(string name) const
{
	return NULL;
}

Feature* PHPWrapperFeatureProvider::getSample(string name) const
{
	return NULL;
}