/**
 * @file
 * @brief Power feature
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-01-15 15:06:13 +0100 (Don, 15 Jän 2004) $
 * $Revision: 505 $
 *
 * @since    Mon Mar 10 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: PowerWindows.cpp 505 2004-01-15 14:06:13Z harald $
 */

#include "Power.h"

void PowerFeatureProvider::nextSample(clock_t checkpoint)
{

#ifdef _WIN32_WCE
	SYSTEM_POWER_STATUS_EX stat;
	this->pluggedValid = GetSystemPowerStatusEx(&stat, true) ? true : false;
#else
	SYSTEM_POWER_STATUS stat;
	this->pluggedValid = GetSystemPowerStatus(&stat) ? true : false;
#endif

	if (this->pluggedValid) {
		this->plugged = stat.ACLineStatus ? true : false;
	}
}