/**
 * @file
 * @brief Wlan feature
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-06-15 21:37:06 +0200 (Die, 15 Jun 2004) $
 * $Revision: 823 $
 *
 * @since    Mon Jul 7 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: WlanAP.cpp 823 2004-06-15 19:37:06Z rene $
 */

//@{
/** Default properties */
#define SYSTEM_COMMAND_1_CISCO "curl http://"
#define SYSTEM_COMMAND_2_CISCO "/ShowAssociations.shm -O - -q | grep -B 1 '<font color=\"green\">Assoc</font>' | grep 'MAC=' | sed 's/<[^<]*>//g;s/&nbsp;//g'"
#define SYSTEM_COMMAND_1_LINKSYS "curl --silent --basic --user \" :"
#define SYSTEM_COMMAND_2_LINKSYS "\" --insecure https://"
#define SYSTEM_COMMAND_3_LINKSYS "/WL_ActiveTable.asp | grep -A 256 'Active PC' | grep -B 256 'Inactive PC' | grep '<TD height=\"20\" width=\"156\">' | cut -d'>' -f3 | cut -d'<' -f1"
#define DEFAULT_ADDRESS "140.78.95.197"
//@}

#include "WlanAP.h"

EXPORT_FEATURE(WlanAccessPointFeatureProvider);

WlanAccessPointFeatureProvider::WlanAccessPointFeatureProvider(featureparams &params) :
	SystemCommandStringListFeatureProvider("WlanAccessPoint", "Clients", "",
		 &features, &clientsFeature_code, &clientsFeature_maxlen, params)

{
	string address, password;
	if (params.count("address") == 0)
		address = DEFAULT_ADDRESS;
	else
		/// @todo check parameter !!
		address = params["address"];
	if (params.count("password") != 0)
		password = params["password"];
	
	if (params.count("type") != 0 && params["type"] == "linksys")
		systemCommand = SYSTEM_COMMAND_1_LINKSYS + password + SYSTEM_COMMAND_2_LINKSYS + address + SYSTEM_COMMAND_3_LINKSYS;
	else
		systemCommand = SYSTEM_COMMAND_1_CISCO + address + SYSTEM_COMMAND_2_CISCO;

	features.push_back("Clients");

	// start the system command thread
	this->start();
}

WlanAccessPointFeatureProvider::~WlanAccessPointFeatureProvider() throw()
{
	this->SystemCommandStringListFeatureProvider::~SystemCommandStringListFeatureProvider();
}
