/**
 * @file
 * @brief A simple %Predictor using averages (median for ordinal time series, most frequent for categorical/nominal) as predicted next values.
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-23 12:25:16 +0100 (Mon, 23 Feb 2004) $
 * $Revision: 636 $
 *
 * @since    Wed Mar 19 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: AveragePredictor.h 636 2004-02-23 11:25:16Z rene $
 */

#ifndef _AVERAGEPREDICTOR_H
#define _AVERAGEPREDICTOR_H

#include "../Predictor.h"

/**
 * @todo documentation
 */
class AveragePredictor: public PredictorAlgorithm
{
	private:
		//@{
		/**
		 * Private property
		 * @todo documentation
		 */
		unsigned windowSize;
		list<unsigned> window;
		map<unsigned, unsigned> frequencies;

	public:
		// currently we only do most frequent prediction, as we only have categorical values
		//enum AveragingType { mean, movingAverage, exponentialSmoothing, median };

		//AveragePredictor(AveragingType type, unsigned int windowSize);
		/** @todo documentation */
		AveragePredictor(predictorparams &params);

		// add a single step to the model
		virtual void addContexts(const membershiplist* contexts, time_t time);
		virtual void addContext(unsigned long contextId, time_t time);

		virtual unsigned long getNextContext() const;
		virtual membershiplist getNextContexts() const;

		virtual contexttrajectory getContextTrajectory(unsigned int start, unsigned int end) const;

		virtual unsigned long getContextAt(time_t time) const;
		virtual membershiplist getContextsAt(time_t time) const;

		virtual string serialize() const;
		virtual void unserialize(string data);

#if _DEBUG_PREDICTORS
		/** This is only for testing. */
		virtual string toString() const;
#endif
};

#endif
