#! /bin/sh

FLAGS="defaults 23"
DAEMON=/usr/bin/features
PIDFILE=/var/run/features

test -f $DAEMON || exit 0

case "$1" in
	start)
		echo -n "Starting feature collection: features"
  		start-stop-daemon --start --quiet --exec $DAEMON --pidfile $PIDFILE --make-pidfile --background
		echo "."
  		;;
	stop)
		echo -n "Stopping feature collection: features"
  		start-stop-daemon --stop --quiet --exec $DAEMON --pidfile $PIDFILE
		echo "."
  		;;
	restart|force-reload)
        	$0 stop
  		sleep 2
                $0 start
  		;;
	*)
  		echo "Usage: $0 {start|stop|restart|force-reload}"
  		exit 1
		;;
esac

exit 0
