/*
 * Created on Oct 6, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package at.jku.intelligence.context;

import java.util.Iterator;
import java.util.HashMap;

/**
 * @author rene
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Context {
	static {
		System.loadLibrary("procaJNI");
	}
	
	public static boolean init(String configFilename, String persistFilename, String gngPersistFilename) {
		return nativeInit(configFilename, persistFilename, gngPersistFilename);
	}
	
	public static long nextSample() throws Exception {
		long ret = nativeNextSample();
		if (ret == -1)
			throw new Exception("not initialized");
		
		return ret;
	}
	
	public static HashMap getClusterMembership() throws Exception {
		int numClusters = nativeGetNumClusters();
		if (numClusters == -1)
			throw new Exception("not initialized");
			
		long[] classes = new long[numClusters];
		double[] memberships = new double[numClusters];
		HashMap ret = new HashMap();
		
		nativeGetClusterMembership(classes, memberships);
		if (classes.length != memberships.length)
			throw new Exception("invalid result from native library");
		
		for (int i=0; i<numClusters; i++) {
			ret.put(new Long(classes[i]), new Double(memberships[i]));
		}
		
		return ret;
	}
	
	public static void main(String[] args) throws Exception {
		System.out.println("P2P Intelligence: Context interface");
		System.out.println("P2P Intelligence: initializing");
		init("config.xml", "persist.xml", "gngdata.txt");
		System.out.println("P2P Intelligence: entering main loop");
		while(true) {
			long bestMatchingContextId;
			
			System.out.println("P2P Intelligence: calling nextSample");
			bestMatchingContextId = nextSample();
			System.out.println("P2P Intelligence: current best matching context ID is " + bestMatchingContextId);
			System.out.println("P2P Intelligence: getting context class vector");
			HashMap memberships = getClusterMembership();
			Iterator iter = memberships.keySet().iterator();
			while (iter.hasNext()) {
				long classId = ((Long) iter.next()).longValue();
				double membership = ((Double) memberships.get(new Long(classId))).doubleValue();
				System.out.println("Context class ID " + classId + " with membership " + membership);
			}
			Thread.sleep(5000);
		}
	}
	
	private static native boolean nativeInit(String configFilename, String persistFilename, String gngPersistFilename);
	private static native long nativeNextSample();
	// passing a hashmap from C++ to Java is slow via JNI - therefore we pass two lists and reconstruct the map in Java
	private static native int nativeGetNumClusters();
	private static native void nativeGetClusterMembership(long[] classes, double[] memberships);
}
