/*
 * Created on May 7, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package at.jku.intelligence.samples;

/**
 * @author rene
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Sample {
	protected int nativeObjectRef;
	
	public final static int TYPE_boolean = 0;
	public final static int TYPE_nominal = 1;
	public final static int TYPE_ordinal = 2;
	public final static int TYPE_numerical_discrete = 3;
	public final static int TYPE_numerical_continuous = 4;
	
	protected void checkValidity() {
		if (nativeObjectRef == 0)
			throw new RuntimeException("Native object not valid");
	}
	
	protected Sample() {
	}
	
	public Sample(int objectRef) {
		nativeObjectRef = objectRef;
	}
	
	public boolean isValid() {
		return (nativeObjectRef != 0);
	}
	
	public double getPosition() {
		checkValidity();
		return nativeGetPosition(nativeObjectRef);	
	}
	
	public int getType() {
		checkValidity();
		return nativeGetType(nativeObjectRef);
        }

        // the textual name of the feature (e.g. Wlan.ActiveEssid)
        public String getName() {
		checkValidity();
		return nativeGetName(nativeObjectRef);
        }
	
/*	public String toString() {
		checkValidity();
		return nativeToString(nativeObjectRef);
	}*/
	
	public void finalize() {
		if (nativeObjectRef != 0)
			nativeFreeObject(nativeObjectRef);
	}
	
	// native methods
	private native double nativeGetPosition(int objectRef);
	private native int nativeGetType(int objectRef);
	private native void nativeFreeObject(int objectRef);
	private native String nativeGetName(int objectRef);
//	private native String nativeToString(int objectRef);
}
