#pragma once

#define WINDOWS_LEAN_AND_MEAN
#define POLARITY
#ifndef _WIN32_WCE
#define _WIN32_DCOM
#endif

#include <windows.h>
#include "intelligence_h.h"

#include "../Features/Feature.h"

class FeatureContainer;
class Classifier;

class CIntelligence : public IIntelligence, ISupportErrorInfo
{
	private:
		FeatureContainer *f;
		Classifier *ca;

		const featurevector *samples;
		const char *classes;
		long activeId;

		static ULONG		refCount;
		static ITypeInfo	*typeInfo;

		void calcActiveId();

	public:
		CIntelligence();
		~CIntelligence();

		//custom members
		void nextSample();
		bool wait(bool &keepRunning);

		//IUnknown members
		STDMETHODIMP			QueryInterface(REFIID, LPVOID*);
		STDMETHODIMP_	(ULONG)	AddRef();
		STDMETHODIMP_	(ULONG)	Release();

		// IDispatch members
		STDMETHODIMP GetTypeInfoCount(UINT *);
		STDMETHODIMP GetTypeInfo(UINT, LCID, ITypeInfo **);
		STDMETHODIMP GetIDsOfNames(REFIID, LPOLESTR *, UINT, LCID, DISPID *);
		STDMETHODIMP Invoke(DISPID, REFIID, LCID, WORD, DISPPARAMS *, VARIANT *, EXCEPINFO *, UINT *);

		//ISupportErrorInfo members
		STDMETHODIMP InterfaceSupportsErrorInfo(REFIID riid);

		//IIntelligence members
		STDMETHOD(getActiveId)(long* id);
};
