#pragma once

#include "Intelligence.h"

class CIntelligenceFactory : public IClassFactory
{
	private:
		ULONG	lockCount;
		ULONG	refCount;
		DWORD	regToken;

	public:
		static CIntelligence *intelligence;

		CIntelligenceFactory();
		~CIntelligenceFactory();

		static HRESULT reg();
		static HRESULT unreg();

		//IUnknown members
		STDMETHODIMP			QueryInterface(REFIID, LPVOID*);
		STDMETHODIMP_	(ULONG)	AddRef();
		STDMETHODIMP_	(ULONG)	Release();

		//IClassFactory members
		STDMETHODIMP			CreateInstance(LPUNKNOWN, REFIID, LPVOID*);
		STDMETHODIMP			LockServer(BOOL);

		STDMETHODIMP			Register();
		STDMETHODIMP			Unregister();
		STDMETHODIMP_	(BOOL)	StartServer();
		STDMETHODIMP_	(VOID)	StopServer();
};
