/**
 * @file
 * @brief Windows NT service
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-21 23:58:58 +0100 (Sam, 21 Feb 2004) $
 * $Revision: 628 $
 *
 * @since    Tue Aug 8 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: servicehost.h 628 2004-02-21 22:58:58Z harald $
 */

#pragma once
#include "../thirdparty/Service/Service.h"

/**
 * @todo documentation
 */
class ServiceHost : public Service
{
public:
	/** Get Service instance */
	static Service* getService();

protected:
	/**
	 * Consturctor
	 *
	 * @param name Servicename
	 * @param desc Description
	 */
	ServiceHost(LPTSTR name, LPTSTR desc) : Service(name, desc) {}

	virtual bool onInstall();
	virtual bool onUninstall();
	/** Init service */
	virtual bool onInit();
	/** Stop service */
	virtual void onStop();
	/** Service main */
    virtual void run();

private:
	/** Flag indicating wheter the service should end or keep running */ 
	static bool keepRunning;
};
