#include "qpixmap.h"
#include "qtimer.h"
#include "qdatetime.h"
#include "qlistview.h"

#include "PreferencesImpl.h"
#include "../thirdparty/trayicon/trayicon.h"

PreferencesImpl::PreferencesImpl()
{
	QTimer *t = new QTimer(this);
	QPixmap pm = *icon();

	oldId = -1;

	Systray->setIcon(pm);
	Systray->setToolTip(QString("Intelligence"));

    t->start(1000); // 1 sec

	connect(t, SIGNAL(timeout()), SLOT(scan()));
}

PreferencesImpl::~PreferencesImpl() {
}

void PreferencesImpl::tray(const QPoint &, int)
{
	QDialog::show();
}

void PreferencesImpl::show()
{
	Systray->show();
}

void PreferencesImpl::hide()
{
	QDialog::hide();
}

void PreferencesImpl::scan()
{
	long newId = scanner.getActiveId();
	Systray->setToolTip(QString::number(newId));

	if (newId != oldId) {
		oldId = newId;

		/// @todo reverse order and limit log backlog length
		QListViewItem *lvi = new QListViewItem(HistoryListView, QDateTime::currentDateTime().toString(), QString::number(newId));
	}
}
