/**
 * @file
 * @brief Abstract thread function implementation
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-23 12:24:40 +0100 (Mon, 23 Feb 2004) $
 * $Revision: 635 $
 *
 * @since    Tue May 13 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: Thread.cpp 635 2004-02-23 11:24:40Z rene $
 */

#include "Thread.h"

Thread::Thread()
{
	started = cancelled = false;
}

Thread::~Thread()
{
	cancel();
	join();
}

void Thread::cancel()
{
//	Guard g(lockShouldTerminate);
	cancelled = true;
}

bool Thread::isCancelled()
{
//	Guard g(lockShouldTerminate);
	return cancelled;
}

Thread::Guard::Guard(Lock& lock) : lock(lock)
{
	lock.lock();
}

Thread::Guard::~Guard()
{
	lock.unlock();
}

