/**
 * @file
 * @brief DLL wrapper
 *
 * This file wraps the library_initialize() and library_finalize()
 * functions for every operating system.
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-01-15 14:06:35 +0100 (Don, 15 Jän 2004) $
 * $Revision: 498 $
 *
 * @since    Thu Jan 15 2004
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: dll.cpp 498 2004-01-15 13:06:35Z harald $
 */

#include "defines.h"

extern "C" {
	void library_initialize();
	void library_finalize();
}

//  DLL exports
#ifdef _SYMBIAN
# define DLL_PROCESS_ATTACH EDllProcessAttach
# define DLL_PROCESS_DETACH EDllProcessDetach
# define RETURN_OK KErrNone

EXPORT_C TInt E32Dll(TDllReason reason)
#elif defined(_WINDOWS)
# define RETURN_OK TRUE

BOOL APIENTRY DllMain(HANDLE module, DWORD reason, LPVOID reserved)
#endif

{
	switch (reason) { 
		case DLL_PROCESS_ATTACH:
			library_initialize();
			break;

		case DLL_PROCESS_DETACH:
			library_finalize();
			break;
	}

	return RETURN_OK;
}
