/**
 * @file
 * @brief Missing Symbian functions implementation
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * @since    Tue Nov 11 2003
 * @date     $Date: 2004-01-15 14:06:35 +0100 (Don, 15 Jän 2004) $
 * @version  $Revision: 498 $
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: symbianstr.c 498 2004-01-15 13:06:35Z harald $
 */

#include <string.h>
#include "symbianstr.h"

wchar_t* wcsncat(wchar_t* dst, const wchar_t* src, size_t count) 
{
	size_t off = wcslen(dst), i = 0;
	while (i < count && !(src[2*i] == 0 && src[2*i+1] == 0)) {
		dst[off+2*i] = src[2*i];
		dst[off+2*i+1] = src[2*i+1];
		i++;
	}
	dst[off+2*i] = 0;
	dst[off+2*i+1] = 0;
	return dst;
}

wchar_t* wcsncpy(wchar_t* dst, const wchar_t* src, size_t count)
{
	size_t i = 0;
	while (i < count && !(src[2*i] == 0 && src[2*i+1] == 0)) {
		dst[2*i] = src[2*i];
		dst[2*i+1] = src[2*i+1];
		i++;
	}
	dst[2*i] = 0;
	dst[2*i+1] = 0;
	return dst;
}
