/**
 * @file
 * @brief Missing Symbian functions declaration
 *
 * &copy; 2003-2004 by Rene Mayrhofer, Harald Radi
 *
 * $Date: 2004-02-12 21:08:39 +0100 (Don, 12 Feb 2004) $
 * $Revision: 612 $
 *
 * @since    Tue Nov 11 2003
 * @author   Rene Mayrhofer <rene@mayrhofer.eu.org>
 * @author   Harald Radi    <harald.radi@nme.at>
 *
 * <hr><strong>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * </strong><hr>
 *
 * $Id: symbianstr.h 612 2004-02-12 20:08:39Z harald $
 */

#ifndef _SYMBIANSTR_H
#define _SYMBIANSTR_H

#ifndef _SYMBIAN
#error This file is only intended for use on Symbian OS
#endif

/**
 * @name Symbian OS Compatibility Functions
 */
//@{

/** wcsncat implementation */
wchar_t* wcsncat(wchar_t*, const wchar_t*, size_t);
/** wcsncpy implementation */
wchar_t* wcsncpy(wchar_t*, const wchar_t*, size_t);
//@}

#endif // _SYMBIANSTR_H
